/* static char version_string[]="$Id: label_func.c,v 1.1 2000/09/19 22:16:27 maosong Exp $"; */
/*
   $Date: 2000/09/19 22:16:27 $
   $Revision: 1.1 $
   $Author: maosong $
   label_func.c
   ٥ *limg 򰷤ե
*/

#include <stdio.h>
#include <stdlib.h>

#include "pset.h"

Label      *limg;
Coordinate imax, jmax;

/*
 * label format
 * ٥limg ؿ
 */
void lab_format(ImageData *imgd)
{
  NumPixel i;

  imax=imgd->imax;
  jmax=imgd->jmax;

  limg=(Label *)myalloc(jmax*imax*sizeof(unsigned short));

  if(sizeof(Label)==sizeof(int)){
    for(i=0;i<jmax*imax;i++)
      *(limg+i)=NOLABEL;
  }
  else if(sizeof(Label)==sizeof(short)){
    /* just for efficiency */
    for(i=0;i<(int)(jmax*imax)/2;i++)
      *((unsigned long *)limg+i)=UNSIGNED_MAX;
    if((jmax*imax)%2==1){
      *(limg+jmax*imax-1)=NOLABEL;
    }
  }
  else{
    fprintf(stderr,"lab_format : the size of Label must be short or int\n");
    exit(1);
  }
}

/*
 * label get
 * ٥limg β(i,j)֤ͤؿ
 */
Label lab_get(Coordinate i, Coordinate j)
{
  return(*(limg+imax*j+i));
}

/*
 * label set
 * ٥limg β(i,j)ͤln ˥åȤؿ
 */
void lab_set(Coordinate i, Coordinate j, Label ln)
{
  *(limg+imax*j+i) = ln;
}

/*
 * free limg
 * ٥limg ΰ
 */
void free_limg()
{
  free(limg);
}
