/*
**  File: BenchScoring.c
**  Purpose: compute a score using error measurements
**  Author: Song Mao (maosong@cfar.umd.edu)
**  Date:   22 March 1999
**  Organization: Language and Media Processing Lab
**                 Center for Automation Research
**                   University of Maryland
**                   College Park, MD 20742
**  $Id: BenchScoring.c,v 1.1 2000/09/19 22:16:27 maosong Exp $
*/

#include "pset.h"

float BenchScoring(BENCH_PARAM *para, ERR_MEASURE *err,
		   WEIGHT *weight)
{
	float score;
	/*
	score =(weight->wSplLine * err->nSplLine +
		weight->wMrgLine * err->nMrgLine +
		weight->wMisLine * err->nMisLine +
		weight->wFALine  * err->nFALine ) /
		weight->wSplLine +
		weight->wMrgLine +
		weight->wMisLine +
		weight->wFALine );
	*/

	score = (float) err->nErrLine / (float)err->nGtLine;
	return(score);

}
