/*
**  File: CalendarTime.c
**  Purpose: get the current calendar time
**  Author: Song Mao (maosong@cfar.umd.edu)
**  Date:   22 March 1999
**  Organization: Language and Media Processing Lab
**                 Center for Automation Research
**                   University of Maryland
**                   College Park, MD 20742
**  $Id: CalendarTime.c,v 1.1 2000/09/19 22:16:27 maosong Exp $
*/

#include <stdio.h>
#include <time.h>
#include <stdlib.h>

char *CalendarTime()
{
	char *calc_time;
	static time_t  atime, *tp;
	struct tm	*ctime;

	calc_time = (char *) malloc (256 * sizeof(char));
	tp = (time_t *) malloc (sizeof(time_t)); 
	atime = time(tp);
	ctime = localtime(tp);
	
	sprintf(calc_time, "%.2d/%.2d/%.4d/ %.2d:%.2d:%.2d", ctime->tm_mon + 1,
		ctime->tm_mday, ctime->tm_year + 1900,
		ctime->tm_hour, ctime->tm_min,
		ctime->tm_sec);
	free(tp);
	return(calc_time);
}
