#include <stdlib.h>
#include <time.h>

/*
#include "TrainSeg.h"
#include "Bench.h"
*/

#include "pset.h"

void GenscoreTestDriver(TRAIN_PROTOCOL *train_protocol, void *seg_param,
			void *bench_param, char *weight_file, float *val, SCORE **score_p)
{

	static clock_t time_s, time_e;

	time_s = clock();
   	(*score_p)->err_rate = (val[1] + 1) * (val[1] + 1) + 
	   	(val[2] - 2) * (val[2] - 2) +
	   	(val[3] - 0.34) * (val[3] - 0.34) +
	   	(val[4] + 5.1) * (val[4] + 5.1) + 3;
	time_e = clock();
	(*score_p)->timing = ((double)(time_e - time_s))/CLOCKS_PER_SEC;
}
